
 /*         
          ,  
  RSI.       -
          . 
 */
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//|                                                _Sol_JRSX_4TF.mq4 |
//|          JRSX: Copyright  2005,            Weld, Jurik Research | 
//|                                          http://weld.torguem.net | 
//|          MQL4: Copyright  2005,                Nikolay Kositsin | 
//|                                   Khabarovsk, violet@mail.kht.ru |   
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
#property indicator_separate_window
// "Solaiman"

#property indicator_buffers 5

#property indicator_level1 25
#property indicator_level2 50
#property indicator_level3 75

#property indicator_color1 DimGray
#property indicator_color2 RoyalBlue
#property indicator_color3 Orchid
#property indicator_color4 Green
#property indicator_color5 Red



#define History   10000



#define UP          1
#define BUY         1
#define NUTRAL      0
#define SELL        -1
#define DOWN        -1

#define  TF1m     1
#define  TF5m     2
#define  TF15m    3
#define  TF30m    4
#define  TF1H     5
#define  TF4H     6
#define  TF1D     7
#define  TF1W     8
#define  TF1MN    9

int   TF_EXTRACT[10] = {
         NULL,
         PERIOD_M1 ,
         PERIOD_M5 ,
         PERIOD_M15 ,
         PERIOD_M30 ,
         PERIOD_H1 ,
         PERIOD_H4 ,
         PERIOD_D1 ,
         PERIOD_W1 ,
         PERIOD_MN1 } ;

//---- input parameters
extern int     Lengh=14;

extern int     TF1 = TF5m ;
extern int     TF2 = TF15m ;
extern int     TF3 = TF30m ;
extern int     TF4 = TF1H ;

//---- buffers
double final1[];
double final2[];
double final3[];
double final4[];
double finala[];

string indi_name = "_Sol_JRSX" ;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
   {
  
   // lastbar = Time[Bars - 1] ;

   SetIndexStyle(0,DRAW_LINE,EMPTY,5);
   SetIndexBuffer(0,final1);

   SetIndexStyle(1,DRAW_LINE,EMPTY,4);
   SetIndexBuffer(1,final2);

   SetIndexStyle(2,DRAW_LINE,EMPTY,3);
   SetIndexBuffer(2,final3);

   SetIndexStyle(3,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(3,final4);

   SetIndexStyle(4,DRAW_LINE,EMPTY,1);
   SetIndexBuffer(4,finala);
   
   SetIndexLabel(0,"TF_"+DoubleToStr(TF_EXTRACT[ TF1 ] , 0 ) ) ;
   SetIndexLabel(1,"TF_"+DoubleToStr(TF_EXTRACT[ TF2 ] , 0 ) ) ;
   SetIndexLabel(2,"TF_"+DoubleToStr(TF_EXTRACT[ TF3 ] , 0 ) ) ;
   SetIndexLabel(3,"TF_"+DoubleToStr(TF_EXTRACT[ TF4 ] , 0 ) ) ;
   SetIndexLabel(4,"final_all");

   //---- name for DataWindow and indicator subwindow label
   string short_name = "_Sol_JRSX_4TF(" + Lengh + ")";
   IndicatorShortName(short_name);

   /*
   SetIndexDrawBegin( 0 , History ) ;
   SetIndexDrawBegin( 1 , History ) ;
   SetIndexDrawBegin( 2 , History ) ;
   SetIndexDrawBegin( 3 , History ) ;
   SetIndexDrawBegin( 4 , History ) ;
   */
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i , j , vv ;
   
      datetime dt ;
      
      int bartfx ;
      double trxh ;
      double trxl ;
      double diff ;
      double sign ;
      
//----
   if(Bars <= Lengh + 10) 
       return(0);
//---- last counted bar will be recounted
   int counted_bars = IndicatorCounted();
   int limit = Bars - counted_bars;
   if(counted_bars > 0) 
       limit++;


   if ( limit > History ) limit = History ;
       
   if ( limit > Bars - Lengh - 1 ) limit = Bars - Lengh - 1 ; 
//-- The Trix Calc
   for(i = limit; i >= 0; i--)
      {
      
      dt = Time[i] ;
      
      bartfx = iBarShift( NULL , TF_EXTRACT[ TF1 ] , dt , false ) ;
      final1[i] = iCustom( NULL , TF_EXTRACT[ TF1 ] , indi_name, Lengh , 0 , bartfx ) ;

      bartfx = iBarShift( NULL , TF_EXTRACT[ TF2 ] , dt , false ) ;
      final2[i] = iCustom( NULL , TF_EXTRACT[ TF2 ] , indi_name, Lengh , 0 , bartfx ) ;

      bartfx = iBarShift( NULL , TF_EXTRACT[ TF3 ] , dt , false ) ;
      final3[i] = iCustom( NULL , TF_EXTRACT[ TF3 ] , indi_name, Lengh , 0 , bartfx ) ;

      bartfx = iBarShift( NULL , TF_EXTRACT[ TF4 ] , dt , false ) ;
      final4[i] = iCustom( NULL , TF_EXTRACT[ TF4 ] , indi_name, Lengh , 0 , bartfx ) ;
      
      finala[i] = ( 3 * final1[i] + 3 * final2[i] + 2 * final3[i] + 1 * final4[i] ) / 9 ;
      
      }  
   return(0);
  }
//+------------------------------------------------------------------+

